<?php

//Put db link here

  $positionlist=$mydb->query("Select distinct docposition ".
                                "from doctor ".
                                "order by docposition"
                            );
  $positionlist=$mydb->query("Select distinct docposition ".
                                "from doctor ".
                                "order by docposition"
                            );
  $specialtylist=$mydb->query("Select distinct specialty ".
                                "from doctor ".
                                "order by specialty"
                            );
  $wardlist=$mydb->query("select wardno, wardname ".
                         "from ward ".
                         "order by wardno"
                        );
?>
<!doctype html>
<html>
    <head>
        <title>Edit Staff</title>
        <style>
            .labelfield {
                display: inline-block;
                font-weight: bold;
                text-align: right;
                vertical-align: top;
                width: 100px;
            }
            .datafield{
                display: inline-block;
                text-align: left;
                vertical-align: top;
                width: 220px;

            }
            .errorfield{
                vertical-align: top;
                color: red;
            }
            .doctorrow{
                display: none;
            }
            .nurserow{
                display: none;
            }
            .errorfield{
                color: red;
            }
        </style>
        <script>
            function docancel()
            {  
                if (confirm('Really cancel?  All changes will be lost!'))
                {
                    blankform();
                }
            }
            function checksave()
            {
                var canenable=true;
                if (staffname.value.length==0)
                {
                    staffnamemsg.innerHTML="Staff name is a mandatory field";
                    canenable=false;
                }
                else
                  staffnamemsg.innerHTML="";
                if (!isdoctor.checked && !isnurse.checked)
                {
                    occupationmsg.innerHTML="Occupation is a mandatory field";
                    canenable=false;
                }
                else
                  occupationmsg.innerHTML="";
                if (wardno.value.length==0)
                {
                    wardnomsg.innerHTML="Ward No is a mandatory field";
                    if (isnurse.checked)
                      canenable=false;
                }
                else
                  wardnomsg.innerHTML="";
                if (specialty.value.length==0)
                {
                    specialtymsg.innerHTML="Specialty is a mandatory field";
                    if (isdoctor.checked)
                      canenable=false;
                }
                else
                  specialtymsg.innerHTML="";
                if (position.value.length==0)
                {
                    positionmsg.innerHTML="Position is a mandatory field";
                    if (isdoctor.checked)
                      canenable=false;
                }
                else
                  positionmsg.innerHTML="";
             savebutt.disabled=!canenable;
            }
            function saverec()
            {
                 const xhttp = new XMLHttpRequest();
                 xhttp.onload = function() {
                   var retvalue=this.responseText;
                   if (!(retvalue.toUpperCase().includes("ERROR")))
                   {
                       blankform();
                   }
                   errormsg=retvalue;
                 }
                 if (isdoctor.checked)
                   xhttp.open("GET", "savestaff.php?"+
                                     "staffno="+staffno.value+
                                     "&staffname="+staffname.value+
                                     "&occupation=d"+
                                     "&specialty="+specialty.value+
                                     "&docposition="+position.value, true);
                 else
                   xhttp.open("GET", "savestaff.php?"+
                                     "staffno="+staffno.value+
                                     "&staffname="+staffname.value+
                                     "&occupation=n"+
                                     "&wardno="+wardno.value, true);
                 xhttp.send();                    
                
            }
            function blankform()
            {
                    makevisible(' ');
                    cancelbutt.focus();
                    staffno.value='';
                    staffno.readOnly=false;
                    staffname.value='';
                    staffname.disabled=true;
                    isdoctor.checked=false;
                    isdoctor.disabled=true;
                    isnurse.checked=false;
                    isnurse.disabled=true;
                    wardno.value="";
                    wardno.disabled=true;
                    position.value="";
                    position.disabled=true;
                    specialty.value="";
                    specialty.disabled=true;
                    staffno.select();
                    staffno.focus();
                    errormsg.innerHTML="";
                    staffnamemsg.innerHTML="";
                    occupationmsg.innerHTML="";
                    wardnomsg.innerHTML="";
                    positionmsg.innerHTML="";
                    specialtymsg.innerHTML="";
                
            }
            function dolookup()
            {
                if (staffno.value.length>0)
                {
                 const xhttp = new XMLHttpRequest();
                 xhttp.onload = function() {
                   var retvalue=this.responseText;
                   if (retvalue=='ID not found!')
                     errormsg.innerHTML='ID not found.  New staff.';
                   else
                   {
                     var staffobj=JSON.parse(this.responseText);
                     staffname.value=staffobj.staffname;
                     if (staffobj.occupation=='n')
                     {
                       isdoctor.checked=false;
                       isnurse.checked=true;
                       wardno.value=staffobj.wardno;
                     }
                     else
                     {
                       isdoctor.checked=true;
                       isnurse.checked=false;
                       if (staffobj.specialty==null)
                         specialty.value="None"
                       else
                         specialty.value=staffobj.specialty;
                       position.value=staffobj.docposition;
                     }
                     makevisible(staffobj.occupation);
                   }
                   staffno.readOnly=true;
                   checksave();

                 }
                 xhttp.open("GET", "getstaff.php?staffno="+staffno.value, true);
                 xhttp.send();                    
                 staffname.disabled=false;
                 staffname.select();
                 staffname.focus();
                 staffno.readOnly=true;
                 isdoctor.disabled=false;
                 isnurse.disabled=false;
                 wardno.disabled=false;
                 position.disabled=false;
                 specialty.disabled=false;
                    
                }
                else
                  blankform();
            }
            function makevisible(whichone)
            {
                var docrowlist=document.querySelectorAll('.doctorrow');
                var nurserowlist=document.querySelectorAll('.nurserow');
                var x=0;;
                
                if (whichone=='d')
                {
                    for (x=0; x<docrowlist.length; x++)
                      docrowlist[x].style.display='inline';
                    for (x=0; x<nurserowlist.length; x++)
                      nurserowlist[x].style.display='none';
                }
                else if (whichone=='n')
                {
                    for (x=0; x<docrowlist.length; x++)
                      docrowlist[x].style.display='none';
                    for (x=0; x<nurserowlist.length; x++)
                      nurserowlist[x].style.display='inline';
                    
                }
                else
                {
                    for (x=0; x<docrowlist.length; x++)
                      docrowlist[x].style.display='none';
                    for (x=0; x<nurserowlist.length; x++)
                      nurserowlist[x].style.display='none';
                    
                }
                checksave();
            }
        </script>
    </head>
    <body>
        <form>
                <div>
                    <span class="labelfield"><label for="staffno">ID:</label></span>
                    <span class="datafield">
                        <input type="number" 
                               id="staffno" 
                               name="staffno"
                               min="1"
                               placeholder="-ID here-"
                               style="width: 60px"
                               onblur=dolookup();
                        />
                    </span>
                    <span class="errorfield" id="errormsg"></span>
                </div>
                <div>
                    <span class="labelfield"><label for="staffname">Name:</label></span>
                    <span class="datafield">
                        <input type="text" 
                               id="staffname" 
                               placeholder="-enter name here-"
                               name="staffname"
                               disabled
                               onblur="checksave();"
                        />
                    </span>
                    <span class="errorfield" id="staffnamemsg"></span>

                </div>
                <div>
                    <span class="labelfield"><label >Occupation:</label></span>
                    <span class="datafield">
                        <input type="radio" 
                               id="isdoctor" 
                               name="occupation"
                               value="d"
                               onclick=makevisible('d');
                               disabled
                        /><label for="isdoctor">doctor</label><br />
                        <input type="radio" 
                               id="isnurse" 
                               name="occupation"
                               value="n"
                               onclick=makevisible('n');
                               disabled
                        /><label for="isnurse">nurse</label>
                    </span>
                    <span class="errorfield" id="occupationmsg"></span>

                </div>
                <div class="nurserow">
                    <span class="labelfield"><label >Ward:</label></span>
                    <span class="datafield">
                        <select name="wardno" id="wardno" disabled onchange="checksave();">
                            <option value="">-put wardno here-</option>
                            <?php
                              foreach ($wardlist as $row)
                              {
                            ?>
                              <option value="<?php echo $row['wardno']?>">
                                  <?php echo $row['wardno'];?>
                                  <?php echo $row['wardname'];?>
                              </option>
                            <?php
                              }
                            ?>
                        </select>
                    </span>
                    <span class="errorfield" id="wardnomsg"></span>
                    
                </div>
                <div class="doctorrow">
                    <span class="labelfield"><label >Position:</label></span>
                    <span class="datafield">
                        <select name="position" id="position" disabled onchange="checksave();">
                            <option value="">-put position here-</option>
                            <?php
                              foreach ($positionlist as $row)
                              {
                            ?>
                              <option value="<?php echo $row['docposition']?>">
                                  <?php echo $row['docposition'];?>
                              </option>
                            <?php
                              }
                            ?>
                        </select>
                    </span>
                    <span class="errorfield" id="positionmsg"></span>
                    
                </div><br />

                <div class="doctorrow">
                    <span class="labelfield"><label >Specialty:</label></span>
                    <span class="datafield">
                        <select name="specialty" id="specialty" disabled onchange="checksave();">
                            <?php
                              foreach ($specialtylist as $row)
                              {
                                if (strlen($row['specialty'])==0)
                                {
                            ?>
                              <option value="None">
                                  None
                              </option>

                            <?php
                                }
                                else
                                {
                            ?>
                              <option value="<?php echo $row['specialty']?>">
                                  <?php echo $row['specialty'];?>
                              </option>
                            <?php
                                }
                              }
                            ?>
                        </select>
                    </span>
                    <span class="errorfield" id="specialtymsg"></span>
                    
                </div>
                <div>
                    <span style="text-align: left; display: inline-block; width: 150px;">
                        <button type="button" onclick="docancel();" id="cancelbutt">Cancel</button>
                    </span>
                    <span style="text-align: right; display: inline-block; width: 150px;">
                        <button type="button" disabled id="savebutt" onclick="saverec();">Save</button></span>
                </div>
       

        </form>
    </body>
</html>